VST 3 SDK: Module Class Reference
Author: Steinberg

VST 3 SDK VST 3.7 SDK for developing VST plug-in

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Module Class Referenceabstract

`#include <module.h>`

## Classes
struct | Snapshot

## Public Types
using | Ptr = std::shared_ptr<Module>
using | PathList = std::vector<std::string>
using | SnapshotList = std::vector<Snapshot>

## Public Member Functions
const std::string & | getName () const noexcept
const std::string & | getPath () const noexcept
const PluginFactory & | getFactory () const noexcept
bool | isBundle () const noexcept

## Static Public Member Functions
static Ptr | create (const std::string &path, std::string &errorDescription)
static PathList | getModulePaths ()
static SnapshotList | getSnapshots (const std::string &modulePath)
static Optional< std::string > | getModuleInfoPath (const std::string &modulePath)
| get the path to the module info json file if it exists
static bool | validateBundleStructure (const std::string &path, std::string &errorDescription)
| validate the bundle structure

## Protected Member Functions
virtual | ~Module () noexcept=default
virtual bool | load (const std::string &path, std::string &errorDescription)=0

## Protected Attributes
PluginFactory | factory {nullptr}
std::string | name
std::string | path
bool | hasBundleStructure {true}

## Member Typedef Documentation

## ◆ Ptr

using Ptr = std::shared_ptr<Module>

## ◆ PathList

using PathList = std::vector<std::string>

## ◆ SnapshotList

using SnapshotList = std::vector<Snapshot>

## Constructor & Destructor Documentation

## ◆ ~Module()

virtual ~Module | ( |  | ) |
| protectedvirtualdefaultnoexcept

## Member Function Documentation

## ◆ create()

Module::Ptr create | ( | const std::string & | path,
|  | std::string & | errorDescription )
| static

## ◆ getModulePaths()

Module::PathList getModulePaths | ( |  | ) |
| static

## ◆ getSnapshots()

Module::SnapshotList getSnapshots | ( | const std::string & | modulePath | ) |
| static

## ◆ getModuleInfoPath()

Optional< std::string > getModuleInfoPath | ( | const std::string & | modulePath | ) |
| static

get the path to the module info json file if it exists

## ◆ validateBundleStructure()

bool validateBundleStructure | ( | const std::string & | path,
|  | std::string & | errorDescription )
| static

validate the bundle structure

## ◆ getName()

const std::string & getName | ( |  | ) | const
| inlinenoexcept

## ◆ getPath()

const std::string & getPath | ( |  | ) | const
| inlinenoexcept

## ◆ getFactory()

const PluginFactory & getFactory | ( |  | ) | const
| inlinenoexcept

## ◆ isBundle()

bool isBundle | ( |  | ) | const
| inlinenoexcept

## ◆ load()

virtual bool load | ( | const std::string & | path,
|  | std::string & | errorDescription )
| protectedpure virtual

## Member Data Documentation

## ◆ factory

PluginFactory factory {nullptr}
| protected

## ◆ name

std::string name
| protected

## ◆ path

std::string path
| protected

## ◆ hasBundleStructure

bool hasBundleStructure {true}
| protected

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.